import { KeyValueDisplay, KeyValueSuggestion } from "./KeyValueDatatypes";
import { KeyValueType } from "./KeyValueType";
export declare class KeyValueEntry<T> {
    isDefault?: boolean;
    private readonly _type;
    private _value;
    constructor(type: KeyValueType<T>);
    readonly type: KeyValueType<T>;
    readonly id: string;
    readonly label: string;
    getSuggestions(prefix: string): KeyValueSuggestion[];
    parse(val: T | string): T | undefined;
    set(val: T | string): boolean;
    readonly value: T | undefined;
    readonly isPartial: boolean;
    readonly display: KeyValueDisplay | undefined;
    readonly editText: string | undefined;
    equals(entry: KeyValueEntry<any>): boolean;
}
