import { KeyValueSuggestion, KeyValueTextDisplay } from "./KeyValueDatatypes";
import { KeyValueType } from "./KeyValueType";
import { NumberDelimiters } from "../helpers/formatting";
import NumberFormat = Intl.NumberFormat;
declare type Operator = "=" | "*" | "/" | "+" | "-";
declare type OpSymbol = "=" | "*" | "÷" | "+" | "-";
interface SlackNumberModifierKeyValue {
    operator: OpSymbol | Operator;
    number: number;
}
interface NumberModifierKeyValue extends SlackNumberModifierKeyValue {
    operator: Operator;
}
export declare type RoundMode = "not" | "up" | "down" | "math";
export default class NumberModifierKeyValueType extends KeyValueType<NumberModifierKeyValue> {
    static apply(value: NumberModifierKeyValue, number: number, roundMode?: RoundMode): number;
    private _delimiters;
    private _groupsDelimiterRegex;
    delimiters: NumberDelimiters;
    private _numberFormatter?;
    numberFormatter: NumberFormat | undefined;
    getSuggestions(prefix: string): KeyValueSuggestion[];
    parseString(val: string): NumberModifierKeyValue | undefined;
    checkValue(val: any): NumberModifierKeyValue | undefined;
    display(value: SlackNumberModifierKeyValue): KeyValueTextDisplay;
    editText(value: SlackNumberModifierKeyValue): string;
}
export {};
