var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { KeyValueType } from "./KeyValueType";
export var ascendingValues = ["aufsteigend", "auf", "asc", "ascending", "up", "1", "+"];
export var descendingValues = ["absteigend", "ab", "desc", "descending", "down", "-1", "-"];
var SortKeyValueType = /** @class */ (function (_super) {
    __extends(SortKeyValueType, _super);
    function SortKeyValueType() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SortKeyValueType.mongoSpecifierFor = function (value) {
        return value ? "asc" : "desc";
    };
    SortKeyValueType.prototype.getSuggestions = function (prefix) {
        var substringLower = prefix.toLowerCase();
        var ascendingValue = ascendingValues.find(function (val) { return val.includes(substringLower); });
        var descendingValue = descendingValues.find(function (val) { return val.includes(substringLower); });
        return [
            { display: this.display(true), match: ascendingValue, value: ascendingValues[0] },
            { display: this.display(false), match: descendingValue, value: descendingValues[0] },
        ].filter(function (o) { return o.match !== undefined; });
    };
    SortKeyValueType.prototype.parseString = function (val) {
        var value = val.trim().toLowerCase();
        if (value === "" || ascendingValues.includes(value)) {
            return true;
        }
        else if (descendingValues.includes(value)) {
            return false;
        }
        else {
            return undefined;
        }
    };
    SortKeyValueType.prototype.checkValue = function (val) {
        if (typeof val === "boolean") {
            return val;
        }
        else {
            return undefined;
        }
    };
    SortKeyValueType.prototype.display = function (value) {
        if (value) {
            return { html: "<i class='fa fa-sort-up'></i>" };
        }
        else {
            return { html: "<i class='fa fa-sort-down'></i>" };
        }
    };
    SortKeyValueType.prototype.editText = function (value) {
        if (value) {
            return ascendingValues[0];
        }
        else {
            return descendingValues[0];
        }
    };
    return SortKeyValueType;
}(KeyValueType));
export default SortKeyValueType;
